# vpath is set to odemx/ so that all sources with module dir prefix are found
VPATH:=..

# automatically create and add object names from wildcard source names
OBJECTS:=$(OBJECTS) $(patsubst ../base/%.cpp, base/%.o, $(wildcard ../base/*.cpp))
OBJECTS:=$(OBJECTS) $(patsubst ../base/continuous/%.cpp, base/continuous/%.o, $(wildcard ../base/continuous/*.cpp))
OBJECTS:=$(OBJECTS) $(patsubst ../base/cellular_automaton/%.cpp, base/cellular_automaton/%.o, $(wildcard ../base/cellular_automaton/*.cpp))
OBJECTS:=$(OBJECTS)	$(patsubst ../coroutine/%.cpp, coroutine/%.o, $(wildcard ../coroutine/*.cpp))
OBJECTS:=$(OBJECTS) $(patsubst ../data/%.cpp, data/%.o, $(wildcard ../data/*.cpp))
OBJECTS:=$(OBJECTS) $(patsubst ../data/buffer/%.cpp, data/buffer/%.o, $(wildcard ../data/buffer/*.cpp))
OBJECTS:=$(OBJECTS) $(patsubst ../data/output/%.cpp, data/output/%.o, $(wildcard ../data/output/*.cpp))
OBJECTS:=$(OBJECTS) $(patsubst ../global/%.cpp, global/%.o, $(wildcard ../global/*.cpp))
OBJECTS:=$(OBJECTS) $(patsubst ../protocol/%.cpp, protocol/%.o, $(wildcard ../protocol/*.cpp))
OBJECTS:=$(OBJECTS) $(patsubst ../random/%.cpp, random/%.o, $(wildcard ../random/*.cpp))
OBJECTS:=$(OBJECTS) $(patsubst ../statistics/%.cpp, statistics/%.o, $(wildcard ../statistics/*.cpp))
OBJECTS:=$(OBJECTS) $(patsubst ../synchronization/%.cpp, synchronization/%.o, $(wildcard ../synchronization/*.cpp))
OBJECTS:=$(OBJECTS) $(patsubst ../util/%.cpp, util/%.o, $(wildcard ../util/*.cpp))

# prepend Debug or Release prefix to create full object names for different targets
DEBUG_OBJECTS = $(patsubst %.o, Debug/%.o, $(OBJECTS))
RELEASE_OBJECTS = $(patsubst %.o, Release/%.o, $(OBJECTS))
TEST_OBJECTS = $(patsubst %.o, Test/%.o, $(OBJECTS))